%global githash 4009da2e
%global exportdate 20151029

%global snapshot %{exportdate}git%{githash}
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}

Name:           letsencrypt
Version:        0
Release:        1.%{snapshot}%{?dist}
Summary:        Let's Encrypt client

# TODO: check source code to verify license
License:        ASL 2.0 
URL:            https://letsencrypt.org/
Source0:        %{name}-%{githash}.tar.xz
Source1:        export-git-snapshot.sh

BuildArch:      noarch
BuildRequires:  python-devel
BuildRequires:  python-setuptools

Requires:       python-acme = %{version}-%{release}
# specified version requirements from upstream as EPEL might ship older versions
# still in review, rhbz 1198473
# https://bugzilla.redhat.com/show_bug.cgi?id=1198473
Requires:       python-configargparse
Requires:       python-configobj
# load_pem_x509_certificate
Requires:       python-cryptography >= 0.7
Requires:       python-parsedatetime
# net_connections introduced in 2.1.0
%if 0%{?fedora} >= 23
Requires:       python2-psutil >= 2.1.0
%else
Requires:       python-psutil >= 2.1.0
%endif
Requires:       pyOpenSSL
# needs to be packaged:
# https://pypi.python.org/pypi/pyRFC3339
Requires:       python-pyrfc3339
# in Fedora but needs update
# https://bugzilla.redhat.com/show_bug.cgi?id=998103
Requires:       python-dialog >= 3.2.2rc1
Requires:       pytz
Requires:       python-requests
Requires:       python-setuptools
Requires:       python-six
Requires:       python-zope-component
Requires:       python-zope-interface

%description
The Let's Encrypt Client is a tool to automatically receive and install X.509
certificates to enable TLS on servers. The client will interoperate with the
Let’s Encrypt CA which aims to lower the barriers to entry for encrypting all
HTTP traffic on the internet.

This client automates proving domain control to the CA and submitting a CSR
as well as installing issues certificates.


%package -n python-acme
Summary:        ACME protocol implementation in Python
Group:          Development/Libraries
# for Python < 2.7 also include python-argparse
# rsa_recover_prime_factors (>=0.8)
Requires:       python-cryptography >= 0.8
# urllib3 InsecurePlatformWarning (#304)
Requires:       python-ndg_httpsclient
# urllib3 InsecurePlatformWarning (#304)
Requires:       python-pyasn1
# X509Req.get_extensions (>=0.15)
Requires:       pyOpenSSL >= 0.15
# needs to be packaged: https://pypi.python.org/pypi/pyRFC3339
Requires:       python-pyrfc3339
Requires:       pytz
Requires:       python-mock
Requires:       python-requests
Requires:       python-setuptools
Requires:       python-six
Requires:       python-werkzeug

%description -n python-acme
This is a library used by the Let's Encrypt client for the ACME (Automated
Certificate Management Environment). The ACME protocol is designed as part of
the Let's Encrypt project, to make it possible to setup an HTTPS server and
have it automatically obtain a browser-trusted certificate, without any human
intervention. This library implements the protocol used for proving the control
of a domain.


%prep
%setup -q -n %{name}-%{githash}


%build
(cd acme && CFLAGS="$RPM_OPT_FLAGS" %{__python} setup.py build)
CFLAGS="$RPM_OPT_FLAGS" %{__python} setup.py build


%install
(cd acme && %{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT)
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT

# TODO: run unit tests

 
%files
%doc LICENSE.txt
%{_bindir}/jws
%{_bindir}/letsencrypt
%{_bindir}/letsencrypt-renewer
# TODO: remove tests
%{python_sitelib}/letsencrypt
%{python_sitelib}/letsencrypt-*.egg-info

%files -n python-acme
%defattr(-,root,root)
%doc acme/LICENSE.txt
# TODO: remove testdata
%{python_sitelib}/acme
%{python_sitelib}/acme-*.egg-info


%changelog
* Thu Oct 29 2015 Felix Schwarz <fschwarz@fedoraproject.org> 0-1.20151029git4009da2e
- fix dependency issues

* Wed Oct 28 2015 Felix Schwarz <fschwarz@fedoraproject.org> 0-1.20151028git524f46d
- update to latest git snapshot (524f46d)
- change package name to "letsencrypt" (compatible with Debian)
- add python-acme subpackage (because upstream treats this effectively as a
  different project with its own requirements)
- add missing requires

* Sun Apr 26 2015 Torrie Fischer <tdfischer@hackerbots.net> 0-1.gitd045f7c
- Initial package

